package surfaces;

import javax.media.j3d.BranchGroup;
import javax.media.j3d.Shape3D;

import sceneGraphBuilderUtils.ControlledUniverse;
import sceneGraphBuilderUtils.SGBuilder;

public class Surface extends ControlledUniverse {

  public Surface(String title, SurfaceGeometry g) {
    super(title, sceneGraph(title, g), plum);
    positionTheViewingPlatform(g.getViewingPosition());
  }

  public static BranchGroup sceneGraph(String title, SurfaceGeometry g) {
    BranchGroup figure = SGBuilder.newBranchGroup(title);

    // Use the same geometry in both shapes.
    figure.addChild(new Shape3D(g, SGBuilder.frontSurface()));
    figure.addChild(new Shape3D(g, SGBuilder.wireFrame()));

    return figure;
  }

}